package com.zhibao.crm.ocr;

import com.baidu.aip.error.AipError;
import com.baidu.aip.http.AipRequest;
import com.baidu.aip.ocr.AipOcr;
import com.baidu.aip.util.Util;
import com.zhibao.crm.erp.admin.entity.AdminFile;
import com.zhibao.crm.utils.ImageUtils;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.json.JSONObject;

public class BiaduOcrApi extends AipOcr {

   public static Map URL_MAP = urlMap();
   public static Map NAME_MAP = nameMap();
   public static final String APP_ID = "25858223";
   public static final String API_ID = "G7Q1akc2RNQN3g1Kl8cwwp3H";
   public static final String API_SECRET = "bvpB4yR0I3lAZDVHdc3VVy670N2lrpUR";
   static final String MEDICAL_CLASSIFY = "https://aip.baidubce.com/rest/2.0/ocr/v1/medical_recipts_classify";
   static final String YYZZ_URL = "https://aip.baidubce.com/rest/2.0/ocr/v1/business_license";


   public BiaduOcrApi(String appId, String apiKey, String secretKey) {
      super(appId, apiKey, secretKey);
   }

   public static JSONObject businessLicense(String path) {
      BiaduOcrApi client = new BiaduOcrApi("25858223", "G7Q1akc2RNQN3g1Kl8cwwp3H", "bvpB4yR0I3lAZDVHdc3VVy670N2lrpUR");

      try {
         new JSONObject();
         JSONObject e = client.receiptByUrl("https://aip.baidubce.com/rest/2.0/ocr/v1/business_license", path, (HashMap)null);
         return e;
      } catch (Exception var3) {
         var3.printStackTrace();
         return null;
      }
   }

   public static void main(String[] args) {
      businessLicense("G7Q1akc2RNQN3g1Kl8cwwp3H");
   }

   public static Map urlMap() {
      HashMap map = new HashMap();
      map.put("medical_invoice", "https://aip.baidubce.com/rest/2.0/ocr/v1/medical_invoice");
      map.put("medical_vat", "https://aip.baidubce.com/rest/2.0/ocr/v1/vat_invoice");
      map.put("medical_statement", "https://aip.baidubce.com/rest/2.0/ocr/v1/medical_statement");
      map.put("medical_detail", "https://aip.baidubce.com/rest/2.0/ocr/v1/medical_detail");
      map.put("medical_summary", "https://aip.baidubce.com/rest/2.0/ocr/v1/medical_summary");
      map.put("medical_record", "https://aip.baidubce.com/rest/2.0/ocr/v1/medical_record");
      map.put("others", "https://aip.baidubce.com/rest/2.0/ocr/v1/medical_invoice");
      map.put("idcard", "https://aip.baidubce.com/rest/2.0/ocr/v1/idcard");
      map.put("drive", "https://aip.baidubce.com/rest/2.0/ocr/v1/vehicle_license");
      map.put("bankcard", "https://aip.baidubce.com/rest/2.0/ocr/v1/bankcard");
      map.put("accurate", "https://aip.baidubce.com/rest/2.0/ocr/v1/accurate");
      map.put("seal", "https://aip.baidubce.com/rest/2.0/ocr/v1/seal");
      map.put("classify", "https://aip.baidubce.com/rest/2.0/ocr/v1/multi_card_classify");
      map.put("general", "https://aip.baidubce.com/rest/2.0/ocr/v1/general_basic");
      return map;
   }

   public static Map nameMap() {
      HashMap map = new HashMap();
      map.put("medical_invoice", "医疗发票");
      map.put("medical_vat", "增值税发票");
      map.put("medical_statement", "医疗费用结算单");
      map.put("medical_detail", "医疗费用明细");
      map.put("medical_summary", "出院小结");
      map.put("medical_record", "病案首页");
      map.put("idcard", "身份证");
      map.put("idcardback", "身份证");
      map.put("bankcard", "银行卡");
      map.put("others", "其他资料");
      map.put("门诊发票", "门诊发票");
      map.put("门诊费用清单", "门诊费用清单");
      map.put("门诊病历", "门诊病历");
      map.put("住院发票", "住院发票");
      map.put("入院记录", "入院记录");
      map.put("出院小结", "出院小结");
      map.put("住院费用清单", "住院费用清单");
      map.put("理赔申请书", "理赔申请书");
      map.put("其他", "其他资料");
      map.put("other", "其他资料");
      return map;
   }

   public static JSONObject baiduPost(AdminFile file, String type) throws Exception {
      BiaduOcrApi client = new BiaduOcrApi("25858223", "G7Q1akc2RNQN3g1Kl8cwwp3H", "bvpB4yR0I3lAZDVHdc3VVy670N2lrpUR");
      JSONObject jsonObject = new JSONObject();
      jsonObject.put("status", 1);
      if(type.equals("accurate")) {
         JSONObject front1 = client.classify(file.getPath(), (HashMap)null);
         return front1;
      } else {
         HashMap front = new HashMap();
         HashMap back = new HashMap();
         front.put("id_card_side", "front");
         back.put("id_card_side", "back");
         byte var7 = -1;
         switch(type.hashCode()) {
         case -2131707148:
            if(type.equals("accurate")) {
               var7 = 5;
            }
            break;
         case -1951672427:
            if(type.equals("idcard_front")) {
               var7 = 0;
            }
            break;
         case -1858665652:
            if(type.equals("bankcard")) {
               var7 = 3;
            }
            break;
         case -1193508181:
            if(type.equals("idcard")) {
               var7 = 2;
            }
            break;
         case -284840886:
            if(type.equals("unknown")) {
               var7 = 7;
            }
            break;
         case 3526141:
            if(type.equals("seal")) {
               var7 = 4;
            }
            break;
         case 95852938:
            if(type.equals("drive")) {
               var7 = 6;
            }
            break;
         case 1876569595:
            if(type.equals("idcard_back")) {
               var7 = 1;
            }
         }

         switch(var7) {
         case 0:
            jsonObject = client.receiptByUrl((String)urlMap().get("idcard"), file.getPath(), front);
            jsonObject.put("type", "idcard");
            jsonObject.put("status", 2);
            return jsonObject;
         case 1:
            jsonObject = client.receiptByUrl((String)urlMap().get("idcard"), file.getPath(), back);
            jsonObject.put("type", "idcardback");
            jsonObject.put("status", 2);
            return jsonObject;
         case 2:
            jsonObject = client.receiptByUrl((String)urlMap().get("idcard"), file.getPath(), front);
            jsonObject.put("status", 2);
            return jsonObject;
         case 3:
            jsonObject = client.receiptByUrl((String)urlMap().get("bankcard"), file.getPath(), (HashMap)null);
            jsonObject.put("type", "bankcard");
            jsonObject.put("status", 2);
            return jsonObject;
         case 4:
            jsonObject = client.receiptByUrl((String)urlMap().get("seal"), file.getPath(), (HashMap)null);
            return jsonObject;
         case 5:
            jsonObject = client.receiptByUrl((String)urlMap().get("accurate"), file.getPath(), (HashMap)null);
            jsonObject.put("type", "unknown");
            return jsonObject;
         case 6:
            jsonObject = client.receiptByUrl((String)urlMap().get("drive"), file.getPath(), (HashMap)null);
            jsonObject.put("type", "drive");
            return jsonObject;
         case 7:
            jsonObject = client.receiptByUrl((String)urlMap().get("idcard"), file.getPath(), front);
            if(!jsonObject.isNull("image_status") && (jsonObject.get("image_status").equals("normal") || jsonObject.get("image_status").equals("over_exposure"))) {
               jsonObject.put("type", "idcard");
               return jsonObject;
            } else if(!jsonObject.isNull("image_status") && jsonObject.get("image_status").equals("reversed_side")) {
               jsonObject.put("type", "idcardback");
               return jsonObject;
            } else {
               jsonObject = client.receiptByUrl((String)urlMap().get("accurate"), file.getPath(), (HashMap)null);
               jsonObject.put("type", "unknown");
               return jsonObject;
            }
         default:
            jsonObject.put("type", "other");
            return jsonObject;
         }
      }
   }

   private JSONObject receiptByUrl(String url, String imageUrl, HashMap options) throws IOException {
      AipRequest request = new AipRequest();
      this.preOperation(request);
      if(imageUrl.contains("http")) {
         request.addBody("url", imageUrl);
      } else {
         byte[] data = Util.readFileByBytes(imageUrl);
         String base64Content = com.baidu.aip.util.Base64Util.encode(data);
         request.addBody("image", base64Content);
      }

      if(options != null) {
         request.addBody(options);
      }

      request.setUri(url);
      this.postOperation(request);
      return this.requestServer(request);
   }

   public JSONObject receipt(String url, String image, HashMap options) {
      try {
         byte[] e = Util.readFileByBytes(image);
         return this.receipt(url, (byte[])e, options);
      } catch (IOException var5) {
         var5.printStackTrace();
         return AipError.IMAGE_READ_ERROR.toJsonResult();
      }
   }

   public JSONObject receipt(String url, byte[] image, HashMap options) throws IOException {
      AipRequest request = new AipRequest();
      this.preOperation(request);
      String base64Content = com.baidu.aip.util.Base64Util.encode(image);
      request.addBody("image", base64Content);
      if(options != null) {
         request.addBody(options);
      }

      request.setUri(url);
      this.postOperation(request);
      return this.requestServer(request);
   }

   public static List traverseFolder2(String path) {
      ArrayList fileNames = new ArrayList();
      File file = new File(path);
      if(file.exists()) {
         File[] files = file.listFiles();
         if(files.length == 0) {
            System.out.println("文件夹是空的!");
         } else {
            File[] var4 = files;
            int var5 = files.length;

            for(int var6 = 0; var6 < var5; ++var6) {
               File file2 = var4[var6];
               if(file2.isDirectory()) {
                  System.out.println("文件夹:" + file2.getAbsolutePath());
                  traverseFolder2(file2.getAbsolutePath());
               } else if(!file2.getName().contains("xls")) {
                  fileNames.add(file2);
               }
            }
         }
      } else {
         System.out.println("文件不存在!");
      }

      return fileNames;
   }

   private static double getAccuracy(long size) {
      double accuracy;
      if(size < 900L) {
         accuracy = 0.85D;
      } else if(size < 2047L) {
         accuracy = 0.6D;
      } else if(size < 3275L) {
         accuracy = 0.44D;
      } else {
         accuracy = 0.4D;
      }

      return accuracy;
   }

   public JSONObject idcardByUrl(String uploadPath, String idCardSide, HashMap options) {
      AipRequest request = new AipRequest();
      this.preOperation(request);
      request.addBody("url", uploadPath);
      request.addBody("id_card_side", idCardSide);
      if(options != null) {
         request.addBody(options);
      }

      request.setUri((String)URL_MAP.get("idcard"));
      this.postOperation(request);
      return this.requestServer(request);
   }

   public JSONObject classify(String uploadPath, HashMap options) throws IOException {
      AipRequest request = new AipRequest();
      this.preOperation(request);
      String base64Str;
      if(uploadPath.contains("http")) {
         base64Str = ImageUtils.getImg2Base64(uploadPath);
      } else {
         base64Str = ImageUtils.GetImageStr(uploadPath);
      }

      request.addBody("image", base64Str);
      if(options != null) {
         request.addBody(options);
      }

      request.setUri((String)URL_MAP.get("accurate"));
      this.postOperation(request);
      return this.requestServer(request);
   }

}
